<?php
if(!current_user_can("manage_options"))
{
	die("Accessed Denied");
        exit;
}
function trim_value(&$value) 
{ 
    $value = trim($value); 
}

$msg = '';
if(isset($_REQUEST['submit']))
{
        $mapping = array();
        $users = array();
	if(isset($_FILES['dra_csv'])):
            if($_FILES['dra_csv']['type'] != "text/plain"):
                $msg = 'Only text files can be imported';
            else:
                $fp = fopen($_FILES['dra_csv']['tmp_name'], "r");
                $data = fread($fp, $_FILES['dra_csv']['size']);
                fclose($fp);
                unlink($_FILES['dra_csv']['tmp_name']);
                if(empty($data)):
                    $msg = 'Unrecognized file found';
                else:                   
                    $rows = explode("\n", $data);
                
                    if(count($rows) < 1):
                        $msg = 'Unrecognized file found';
                    elseif(count($rows) < 2):
                        $msg = 'No data supplied';
                    else:
                        $columns = explode(",", $rows[0]);
                        array_walk($columns, "trim_value");
                        $mail_index = -1;
                        $url_index = -1;
                        $index = 0;
                        foreach($columns as $column):                            
                            if($column == "user_email"):
                                $mail_index = $index;
                            endif;
                            if($column == "directory_url"):
                                $url_index = $index;
                            endif;
                            $index++;
                        endforeach;
                        if($mail_index == -1 || $url_index == -1):
                            $msg = 'Unrecognized file found. Invalid Number of Columns';
                        else:
                            for($index = 1; $index < count($rows); $index++):
                                $data_columns = explode(",", $rows[$index]);
                                array_walk($data_columns, "trim_value");
                                //$mapping[$data_columns[$mail_index]][] = $data_columns[$url_index];                               

                                if(!array_key_exists($data_columns[$mail_index], $users)):
                                    $users[$data_columns[$mail_index]] = get_user_by("email", $data_columns[$mail_index]);
                                endif;
                                $mapping[$data_columns[$url_index]] = $users[$data_columns[$mail_index]];
                            endfor;
                        endif;
                    endif;    
                endif;                
            endif;            
        endif;
        $count = 0;
        $listings = get_listings();
        foreach($listings as $listing):
            if(array_key_exists($listing->meta_value, $mapping)):
                $args = array(
                  'ID' =>$listing->ID,
                  'post_author'=>$mapping[$listing->meta_value]->ID 
                );
                wp_update_post($args);
                $count++;
            endif;
        endforeach;
        $msg = "$count listing(s) updated.";
}
?>
<div class="wrap">
<h2>Reassign DirectoryPress Authors</h2>
<div style="float:left;width:100%;padding-top:5px;padding-bottom:5px"><h3><?php echo $msg; ?></h3></div>
<form action="<?php echo $_SERVER['REQUEST_URI'] ?>" method="post" enctype="multipart/form-data">
    <div style="float:left;width:100%;background-color: #a52a2a;color:white;padding:5px;">
        WARNING: Please backup your database before you attempt to run this process. 
        The changes made by this plugin are totally IRREVERSIBLE. <br/>
        <b>THE PLUGIN AUTHOR IS NOT RESPONSIBLE IF IT MESSES UP YOUR WEBSITE. USE AT YOUR OWN RISK.<b/>
    </div>
<table class="form-table">
	<tr>		
		<td>
                    Upload CSV: <input type="file" name="dra_csv"></input><input type="submit" name="submit" class="button" value="Upload" />
                    <br/><small>The CSV file must have columns <b>user_email</b>, <b>directory_url</b> on the first line</small>
                </td>		
	</tr>   
</table>    


</form>